#include "MCola.h"

namespace MCola
{
    //Cabecera PROC/FUNC Aux
    TPuntero BuscarCamionCola(TCola c, TCadena matricula);
    
    // PROC/FUNC del Mdulo
    TCola CrearCola()
    {
          TCola c;
          
          c.frente = NULL;
          c.final = NULL;
          
          return c;
    }
    
    bool ColaVacia(TCola c)
    {
         return (c.frente==NULL);
    }
    
    bool ColaLlena(TCola c)
    {
         TPuntero aux;
         bool llena;
         
         aux = new (TNodoCola);
         
         llena = (aux==NULL);
         
         if (!llena)
         {
            delete(aux);        
         }
         
         return llena;
    }
    
    void MeterCola(TCola &c, TCamion  camion, TErrorCola &e)
    {
        TPuntero nuevo,ptr;
        
        ptr = BuscarCamionCola(c, camion.matricula);
        
        if (ptr!=NULL)
        {   // Si ya est en la cola actualizamos sus datos
            e = NoErrorCola;
            ptr->camion = camion;
        }
        else if (ColaLlena(c))
        {
            e = ErrorColaLlena;
        }
        else
        {
            e = NoErrorCola;
            nuevo= new (TNodoCola);
            nuevo->camion = camion;
            nuevo->sig = NULL;
            
            if (ColaVacia(c))
            {
               c.frente = nuevo;               
            }
            else
            {
                c.final->sig = nuevo;
            }
            
            c.final = nuevo;
        }
    }
    
    void SacarCola(TCola &c, TCamion &camion, TErrorCola &e)
    {
         TPuntero aux;
         
         if (ColaVacia(c))
         {
             e = ErrorColaVacia;
         }
         else
         {
            e = NoErrorCola;
            aux = c.frente;
            camion = aux->camion;
            c.frente = c.frente->sig;
            
            if (c.frente==NULL)
            {
                c.final=NULL;            
            }   
            delete (aux);
         }
    }
    
    void MostrarCola(TCola c)
    {
         TPuntero aux;
         
         aux = c.frente;
         while (aux!=NULL)
         {
               EscribirCamion(aux->camion);
               aux = aux->sig;
         }  
    }
    
    void DestruirCola(TCola &c)
    {
         TPuntero aux;
         
         while (c.frente!=NULL)
         {
               aux = c.frente;
               c.frente = c.frente->sig;
               delete (aux);
         }         
    }

    //Cabecera PROC/FUNC Aux
    TPuntero BuscarCamionCola(TCola c, TCadena matricula)
    {
       TPuntero ptr;
       
       ptr=c.frente;
       
       while ( (ptr!=NULL) && (!IgualCadena(ptr->camion.matricula,matricula)) )       
       {
             ptr = ptr->sig;
       }      
       
       return ptr;
    }
    

}

