#ifndef _MTRASNPORTE_H_
#define _MTRASNPORTE_H_

#include <iostream>
#include <fstream>
#include <cstdlib>
#include "MCadena.h"

using namespace std;
using namespace MCadena;

namespace MTransporte
{
   const char SEP = '$';
   const char SP = ' ';
   
   struct TCoordenadas 
   { 
          double latitud;
          double longitud;
   };
   
   struct TCamion 
   {
          TCadena matricula;
          int year;
          TCadena nombre;
          TCoordenadas coordenadas;
   };
   
   typedef enum { inflamable, contaminante, biologica, radiactiva} TTipo;
   
   struct TMercancia
   { 
          int codigo;
          TCadena descripcion;
          TTipo tipo;
          TCadena matricula;
   };
   
   void EscribirCamion(TCamion camion);
   void EscribirMercancia(TMercancia m);
   TTipo SUC(TTipo t);
   void Tipo_a_Cadena(TTipo t, TCadena &s);
   void Cadena_a_Tipo(TCadena s, TTipo &t, bool &ok);
   void LeerCamion(TCamion &camion);
   void LeerTipoMercancia(TTipo &tipo);
   void LeerMercancia(TMercancia &m, TCadena matriculaCamion);
   void LeerCamionFichTXT(ifstream &fich, TCamion &camion);
   void LeerMercanciaFichTXT(ifstream &fich, TMercancia &m, TCadena matriculaCamion);
   void EscribirCamionFichTXT(ofstream &fich, TCamion camion);
   void EscribirMercanciaFichTXT(ofstream &fich, TMercancia m);

}
#endif

